︠9f5cbf4a-65e9-417e-ab34-e3fd4f75dccds︠
reset()

def f(m,n,k) :
    ell = m/n
    if (ell / (k+1) >= 1) : return 1
    return (2*n*exp(-ell)*(ell^k)*(ell+1)) / (factorial(k)*(k+1-ell))

def bin_search_f_k_bdd(m,n,t,k) :
    while(true) :
        if (f(m,n,k) <= 2^(-t)) : return k
        else : k = (k<<1)

def bin_search_f_k_range(m,n,t,k_min,k_max) :
    if (k_max == 1) : return k_max
    while(true):
        if (k_max == k_min+1) : return k_max
        k_mid = floor((k_max + k_min)>>1)
        if (f(m,n,k_mid) <= 2^(-t)) : k_max = k_mid
        else: k_min = k_mid



def bin_search_f_n_bdd(m,n,t,k) :
    while(true) :
        if (f(m,n,k) <= 2^(-t)) : return n
        else : n = (n<<1)

def bin_search_f_n_range(m,k,t,n_min,n_max) :
    if (n_max == 2) : return n_max
    while(true):
        if (n_max == n_min+1) : return n_max
        n_mid = floor((n_max + n_min)>>1)
        if (f(m,n_mid,k) <= 2^(-t)) : n_max = n_mid
        else: n_min = n_mid


### MAIN CODE
#n = input("Enter n: ")
#print "\n"
#m = input("Enter m: ")
#print "\n"
#t = input("Enter bits of security t: ")
#print "\n"


### USER INPUT


# "m" represents the number of messages
#m=10^(3)
# "n" represents the size of the hash function's range
#n=10^(3)
# "t" represents the bits of security needed
#t=20

#k_max = bin_search_f_bdd(m,n,t,1)
#k_min = max(1,k_max>>1)

#k_just = bin_search_f_range(m,n,t,k_min,k_max)

#print "At k=", k_just, "we have security", f(m,n,k_just)
#print bool(f(m,n,k_just)<=2^(-t))
#print bool(f(m,n,k_just-1)<=2^(-t))



#for (m,n,t) in [(10^3,10^3,20)] :
#    k_max = bin_search_f_k_bdd(m,n,t,1)
#    k_min = max(1,k_max>>1)
#
#    k_just = bin_search_f_k_range(m,n,t,k_min,k_max)
#    print "At k=", k_just, "we have security", f(m,n,k_just)


for (m,k,t) in [ (10^3,3,8), (10^3,5,8), (10^3,9,8), (10^3,17,8)
                , (10^4,3,8), (10^4,5,8), (10^4,9,8), (10^4,17,8)
                , (10^6,3,8), (10^6,5,8), (10^6,9,8), (10^6,17,8)
               ] :
    n_max = bin_search_f_n_bdd(m,1,t,k)     #; print n_max
    n_min = max(2,n_max>>1)

    n_just = bin_search_f_n_range(m,k,t,n_min,n_max)

    print "m=", m
    print "\t t=", 2^(-t)
    print "\t k=", k
    print "\t n=", n_just



︡2addc6ea-fd9c-4425-b7cd-1e3328386c64︡{"stdout":"m= 1000\n\t t= 1/256\n\t k= 3\n\t n= 146183\nm= 1000\n\t t= 1/256\n\t k= 5\n\t n= 5185\nm= 1000\n\t t= 1/256\n\t k= 9\n\t n= 751\nm= 1000\n\t t= 1/256\n\t k= 17\n\t n= 194\nm= 10000\n\t t= 1/256\n\t k= 3\n\t n= 4620047\nm= 10000\n\t t= 1/256\n\t k= 5\n\t n= 92124\nm= 10000\n\t t= 1/256\n\t k= 9\n\t n= 10190\nm= 10000\n\t t= 1/256\n\t k= 17\n\t n= 2332\nm= 1000000\n\t t= 1/256\n\t k= 3\n\t n= 4618927102\nm= 1000000\n\t t= 1/256\n\t k= 5\n\t n= 29076741\nm= 1000000\n\t t= 1/256\n\t k= 9\n\t n= 1844154\nm= 1000000\n\t t= 1/256\n\t k= 17\n\t n= 328696\n"}︡{"done":true}︡
︠52ddaf56-739a-47b6-b0f6-47750a14c4c7︠










